FUNCTION RegistryIconExtraction(Extension AS STRING,BYVAL i AS LONG) AS LONG
		' find the icon for a certain file extension in the registry
		' Konvertert fra Delphi code funnet p internett.http://www.awitness.org/delphi_pascal_tutorial/index.html
	LOCAL hKey,PLargeIcon,PSmallIcon,dwRet AS DWORD
	LOCAL Result,IconHandle,LastError,IconPos AS LONG
	LOCAL ExtractPath AS ASCIIZ * %MAX_PATH
	LOCAL AssocAppInfo AS ASCIIZ * %MAX_PATH
	LOCAL Filename AS ASCIIZ * %MAX_PATH
	LOCAL s1 AS BYTE PTR
	LOCAL sRtrnCode AS ASCIIZ * %MAX_PATH

	s1 = STRPTR(Extension)
	IF @s1[0] <> ASC(".") THEN
		Extension = "." + Extension
	END IF

	IF Extension = ".exe" THEN
		Extension =  ".com"
	END IF

	TRY
		IF RegCreateKeyEx(%HKEY_CLASSES_ROOT,BYVAL STRPTR(Extension),0,"",%REG_OPTION_NON_VOLATILE,%KEY_READ,BYVAL %NULL,hKey,Result) = %ERROR_SUCCESS THEN
			IF RegQueryValueEx(hKey,"", 0, %REG_SZ,AssocAppInfo, SIZEOF(AssocAppInfo)) = %ERROR_SUCCESS THEN
				IF pbRegClose (hKey) <> %ERROR_SUCCESS THEN
				 LastError = GetLastError()
				 IF LastError <> 0 THEN
					 dwRet = FormatMessage(%FORMAT_MESSAGE_FROM_SYSTEM, BYVAL 0&, LastError, 0&, BYVAL VARPTR(sRtrnCode), SIZEOF(sRtrnCode),BYVAL 0&)
					 ? sRtrnCode
				 END IF
				END IF
			 END IF
		END IF
		IF LEN(AssocAppInfo) <> 0 THEN
			AssocAppInfo = AssocAppInfo + "\DefaultIcon"
			IF RegCreateKeyEx(%HKEY_CLASSES_ROOT,BYVAL VARPTR(AssocAppInfo),0,"",_
												%REG_OPTION_NON_VOLATILE,%KEY_READ,BYVAL %NULL,hKey,Result) = %ERROR_SUCCESS THEN
				IF RegQueryValueEx(hKey,"", 0, %REG_SZ, ExtractPath, SIZEOF(ExtractPath)) = %ERROR_SUCCESS THEN
					IF pbRegClose (hKey) <> %ERROR_SUCCESS THEN
					 LastError = GetLastError()
					 IF LastError <> 0 THEN
						 dwRet = FormatMessage(%FORMAT_MESSAGE_FROM_SYSTEM, BYVAL 0&, LastError, 0&, BYVAL VARPTR(sRtrnCode), SIZEOF(sRtrnCode),BYVAL 0&)
						 ? sRtrnCode
					 END IF
					END IF
				END IF
			END IF
		END IF
			' IconPos after comma in key  ie: C:\Program Files\Winzip\Winzip.Exe,0
			' did we get a key for icon, does IconPos exist after comma seperator?
		IF LEN(ExtractPath) AND INSTR(ExtractPath,",") <> 0 THEN
			Filename = PARSE$(ExtractPath,1) ' Filename in registry key is before the comma seperator
				' extract the icon Index from after the comma in the ExtractPath string
			IconPos = VAL(PARSE$(ExtractPath,2))
			'$DEBUG PRINT   filename + str$(iconpos)
				' Filename : convert to Windows Api Pchar null terminated string
				' IconPos : position icon in file - from registry key
				' var Large and small HICON handles returned in PLarge/SmallIcon
				' '1' = number of icons to retrieve
			IconHandle = ExtractIconEx(FileName, IconPos,PLargeIcon, PSmallIcon, 1)
			'if iconhandle < 2 then exit try
		 ' $debug print str$(iconhandle)
				' IconHandle = ExtractIconEx(FileName, -1,0, 0, 0) ' antall icons in the file
				' IconHandle = 0 no icons  = 1 not exe dll or ico file-> default icon?
				' note that according to the API Icon Handle is supposed to have these
				' values when it does not succeed however I have found that it on rare
				' occassions returns 4 billion or some other invalid number, the example
				' that comes to mind on my computer being when it processes a file with
				' the extension CNT ... therefore checking for a valid icon handler is
				' safer and I have modified the code as follows, using in this example
				' the value of the small icon handler as a check
				' otherwise IconHandle = handle to icon
			IF  PSmallIcon <> 0 THEN
				LOCAL idxImage AS LONG
				idxImage = ImageList_addIcon(hImageList, PSmallIcon)
			END IF
			DeleteObject(PLargeIcon)
			DeleteObject(PSmallIcon)
		END IF

	CATCH
		? ERROR$ + " in " + FUNCNAME$
	END TRY
	FUNCTION = IdxImage
END FUNCTION
'---------------------------------------------------------------------------------------------------------------------------
SUB EnumRegKeyFileTypes()

	LOCAL lpName AS ASCIIZ * %MAX_PATH ' Name of subkey
	LOCAL sRtrnCode AS ASCIIZ * %MAX_PATH
	LOCAL OpenKey,i,dRet,dwIndex,LastError AS DWORD ' dwIndex = index OF subkey TO enumerate
	LOCAL RegKey AS LONG
	LOCAL ft AS FILETIME
	LOCAL s1 AS BYTE PTR

	s1 = VARPTR(lpName)

	IF RegOpenKeyEx(%HKEY_CLASSES_ROOT,"",0,%KEY_READ,openKey) <> %ERROR_SUCCESS THEN
		EXIT SUB
	END IF

	TRY
		REDIM ExtSL(0 TO 1024) AS GLOBAL ASCIIZ * 1024
		DO
			 RegKey = RegEnumKeyEx(%HKEY_CLASSES_ROOT,dwIndex,BYVAL VARPTR(lpName),SIZEOF(lpName),BYVAL %NULL,BYVAL %NULL,BYVAL %NULL,ft) ' get a sub key
			 IF RegKey = %ERROR_SUCCESS THEN
				 IF @s1[0] = ASC(".") THEN  ' period indicates a file extension type key
					IF i > UBOUND(ExtSL()) THEN
						REDIM PRESERVE ExtSL(0 TO UBOUND(ExtSL()) + 1024) AS GLOBAL ASCIIZ * 1024
					END IF
					ExtSL(i) = lpName ' save registered file extensions in string array
					INCR i
				 END IF
				 INCR dwIndex ' next index number = next key for next time through loop
			 ELSE
				 IF Regkey <> %ERROR_NO_MORE_ITEMS THEN
					 dRet = FormatMessage(%FORMAT_MESSAGE_FROM_SYSTEM, BYVAL 0&, Regkey, 0&, BYVAL VARPTR(sRtrnCode), SIZEOF( sRtrnCode),BYVAL 0&)
					 ? sRtrnCode
					 EXIT LOOP
				 END IF
			 END IF
		LOOP UNTIL Regkey = %ERROR_NO_MORE_ITEMS OR RegKey <> %ERROR_SUCCESS
		IF i > 0 THEN
		 REDIM PRESERVE ExtSL(0 TO i-1) AS GLOBAL ASCIIZ * 1024
		ELSE
		 REDIM PRESERVE ExtSL(0 TO 0) AS GLOBAL ASCIIZ * 1024
		END IF
	CATCH
		? ERROR$ + " in " + FUNCNAME$
	END TRY
END SUB
'---------------------------------------------------------------------------------------------------------------------------------
SUB GetAssocAppInfoFileTypes()

	LOCAL LastError,i AS LONG
	LOCAL Result,hKey,dwRet AS DWORD
	LOCAL sRtrnCode AS ASCIIZ * %MAX_PATH
	LOCAL szBuffer AS ASCIIZ * 1024

	TRY
		DO
			IF RegCreateKeyEx(%HKEY_CLASSES_ROOT,BYVAL VARPTR(ExtSL(i)),0,"",%REG_OPTION_NON_VOLATILE,%KEY_READ,BYVAL %NULL,hKey,Result) = %ERROR_SUCCESS THEN
				IF RegQueryValueEx(hKey,"", 0, %REG_SZ,szBuffer, SIZEOF(szBuffer)) = %ERROR_SUCCESS THEN
					IF LEN(szBuffer) <> 0 THEN
						ExtSL(i) = ExtSL(i) + "," + szBuffer    ' create comma delimited string list with file extension, assocappinfo key name
					END IF
				END IF
				INCR i                                       ' read the next extension in the string array
			ELSE
			 ARRAY DELETE ExtSL(i)                        ' no assoc app info therefore delete this file extension
			END IF

			IF pbRegClose (hKey) <> %ERROR_SUCCESS THEN
			 LastError = GetLastError()
			 IF LastError <> 0 THEN
				 dwRet = FormatMessage(%FORMAT_MESSAGE_FROM_SYSTEM, BYVAL 0&, LastError, 0&, BYVAL VARPTR(sRtrnCode), SIZEOF(sRtrnCode),BYVAL 0&)
				 ? sRtrnCode
			 END IF
			END IF

		LOOP UNTIL i > UBOUND(ExtSL())
		ARRAY SORT ExtSL()
	CATCH
		? ERROR$ + " in " + FUNCNAME$
	END TRY
END SUB
'-------------------------------------------------------------------------------------------
SUB GetDescStringsFileTypes()

	LOCAL LastError,idx,Result,ub,hKey,i AS LONG
	LOCAL dwRet AS DWORD
	LOCAL AssocAppInfo AS STRING
	LOCAL AssocAppString AS ASCIIZ * 1024
	LOCAL sRtrnCode AS ASCIIZ * %MAX_PATH

	TRY
		REDIM NameSL(0 TO 0) AS GLOBAL STRING 'ASCIIZ * 1024
		DO
			AssocAppInfo = PARSE$(Extsl(i),2)
			IF RegCreateKeyEx(%HKEY_CLASSES_ROOT,BYVAL STRPTR(AssocAppInfo),0,"",%REG_OPTION_NON_VOLATILE,%KEY_READ,BYVAL %NULL,hKey,Result) = %ERROR_SUCCESS THEN
				IF RegQueryValueEx(hKey,"", 0, %REG_SZ,AssocAppString, SIZEOF(AssocAppString)) = %ERROR_SUCCESS THEN
					IF LEN(AssocAppString) <> 0  THEN
						ub = UBOUND(NameSL())
						IF idx > ub  THEN
							REDIM PRESERVE NameSL(0 TO ub + 500) AS GLOBAL STRING 'ASCIIZ * 1024
						END IF
						Namesl(idx) = PARSE$(Extsl(i),1) + "," + AssocAppString 'szBuffer ' save both the file extension and the plain english description on comma delimited stringlist namesl
						INCR idx
					END IF
				END IF
			 END IF
			 IF pbRegClose (hKey) <> %ERROR_SUCCESS THEN
				LastError = GetLastError()
				IF LastError <> 0 THEN
					dwRet = FormatMessage(%FORMAT_MESSAGE_FROM_SYSTEM, BYVAL 0&, LastError, 0&, BYVAL VARPTR(sRtrnCode), SIZEOF(sRtrnCode),BYVAL 0&)
					? sRtrnCode
				END IF
			 END IF
			 INCR i
		LOOP UNTIL i > UBOUND(ExtSL())
		IF idx > 0 THEN
			REDIM PRESERVE NameSL(0 TO idx-1) AS GLOBAL STRING 'ASCIIZ * 1024
		END IF
	 CATCH
		? ERROR$ + " in " + FUNCNAME$
	END TRY
END SUB
'----------------------------------------------------------------------------------------------------------------
SUB GetIconsFileTypes(BYVAL hDlg AS LONG,BYVAL CtrlID AS LONG)

	REGISTER i AS LONG

	LOCAL st,s AS STRING
	LOCAL Result,ImageIndex AS LONG
	LOCAL TXT AS ASCIIZ * 255
	LOCAL cbI AS COMBOBOXEXITEM
	LOCAL hComboboxEx AS LONG

	hComboBoxEx = GetDlgItem(hDlg,%IDC_COMBOBOX_REGISTERED_FILE_TYPES) ' Handle to the Combobox control
	hImageList = ImageList_Create(16,16,%ILC_COLOR, UBOUND(NameSL()) + 1,0) ' create a user defined imagelist
	CONTROL SEND hDlg, CtrlID,%CBEM_SETIMAGELIST,0,hImageList

	cbI.mask   = %CBEIF_TEXT OR %CBEIF_IMAGE OR %CBEIF_SELECTEDIMAGE 'OR %CBEIF_INDENT
	cbI.iItem  = -1

	FOR i = 0 TO UBOUND(NameSL())
		s  = PARSE$(NameSL(i),1)  ' extract the file extension
		st = PARSE$(NameSL(i),2)  ' extract the file description
		TXT = s + " -- " + st
		cbI.pszText        = VARPTR(TXT)
		cbI.cchTextMax     = SIZEOF(TXT)
		cbI.iIndent       = 1  ' If item indention testing is required
		IF LEN(s) <> 0 THEN
		 ImageIndex = RegistryIconExtraction(s,i)
		 '$DEBUG PRINT "Imageindex:"+STR$(ImageIndex) + s + str$(i)
		 cbI.iImage         = ImageIndex
		 cbI.iSelectedImage = ImageIndex
		 CONTROL SEND hDlg, CtrlID, %CBEM_INSERTITEM, 0,VARPTR(cbI) TO Result
		END IF
	NEXT

	COMBOBOX SELECT hDlg,CtrlID,1

END SUB
